
<!doctype html>
<html>
  <head>
    <meta charset="utf-8" />
    <meta http-equiv='X-UA-Compatible' content='IE=edge;chrome=1' />
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>The Amazing Blog - Ruby rescues are not slow</title>
    <link href="/stylesheets/layout.css" rel="stylesheet" />
    <link href="/stylesheets/highlight.css" rel="stylesheet" />
    <link rel="alternate" type="application/atom+xml" title="The Amazing Blog Feed" href="/feed.xml" />
  </head>
  <body>
    <header id="main">
      <h1>
        <a href="/">The Amazing Blog</a>
      </h1>

      <h2>
        <a href="https://github.com/paul/blog.theamazingrando.com"> Source on GitHub </a>
      </h2>
    </header>

    <div id="content" role="main">
      <main>
          <article>
    <header>
      <h1><a href="/ruby-rescues-are-not-slow.html">Ruby rescues are not slow</a></h1>
      <p class="meta">
        Published: <time datetime="2007-11-27T06:21:38Z">Tuesday, November 27th 2007</time></br>
        Updated: <time datetime="2017-02-07T16:49:25-07:00">Tuesday, February 7th 2017</time></br>
        <a href="https://github.com/paul/blog.theamazingrando.com/blob/master/source/posts/ruby-rescues-are-not-slow.html">Article source on GitHub</a>
      </p>
    </header>

    <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<html><body>

<p>I've heard several times that you should avoid exceptions because they are slow. They are in Java, so I think that has given them a bad name everywhere. The only real numbers I could find are from <a href="http://www.notsostupid.com/blog/2006/08/31/the-price-of-a-rescue/" title="http://www.notsostupid.com/blog/2006/08/31/the-price-of-a-rescue/"></a><a href="http://www.notsostupid.com/blog/2006/08/31/the-price-of-a-rescue/">http://www.notsostupid.com/blog/2006/08/31/the-price-of-a-rescue/</a> . His 'plain' test is also missing the conditional that would also have to be executed (In this case, to make sure 5 is not 0). His post is also 18 months old, so I updated the 'plain' test and re-ran it (Upping the runs to 5,000,000). My plain test now looks like:
</p>
<pre lang="ruby">
x.report("plain") do
  for i in 1..n
    if 5.0 != 0.0
      1.0/5.0
    end
  end
end</pre>
And my results:
<pre>
% ruby --version
ruby 1.8.6 (2007-09-24 patchlevel 111) [x86<em>64-linux]
% ruby test</em>rescue.rb
user     system      total        real
plain    4.020000   0.010000   4.030000 (  4.034352)
safe     3.230000   0.010000   3.240000 (  3.238219)
rescue   3.270000   0.010000   3.280000 (  3.289843)</pre>
So it would seem, from my completely unscientific testing, that the rescue is actually <em>faster</em> than bounds-checking.
</body></html>

  </article>

      </main>

      <nav>
        <h1>About the Author</h1>
        <p>
          I am a professional software engineer in Boulder, CO. I love making
          tools for users and fellow developers that are elegant, robust, and
          reliable.
        </p>

        <div class="nav-section">
          <ul>
            <li>GitHub:&nbsp;<a href="https://github.com/paul">@paul</a></li>
            <li>Email:&nbsp;<a href="mailto:paul@sadauskas.com">paul@sadauskas.com</a></li>
            <li>Twitter:&nbsp;<a href="https://twitter.com/theamazingrando">@theamazingrando</a></li>

          </ul>
        </div>

        <h1>Categories</h1>
        <div class="nav-section">
          <ul class="categories">
              <li>
                <a href="/categories/datamapper.html">DataMapper</a>&nbsp;(7)

              </li>
              <li>
                <a href="/categories/gems.html">Gems</a>&nbsp;(6)

              </li>
              <li>
                <a href="/categories/http.html">HTTP</a>&nbsp;(4)

              </li>
              <li>
                <a href="/categories/howto.html">HowTo</a>&nbsp;(4)

              </li>
              <li>
                <a href="/categories/linux.html">Linux</a>&nbsp;(1)

              </li>
              <li>
                <a href="/categories/meta.html">Meta</a>&nbsp;(2)

              </li>
              <li>
                <a href="/categories/mysql.html">MySQL</a>&nbsp;(1)

              </li>
              <li>
                <a href="/categories/tips-tricks.html">Tips & Tricks</a>&nbsp;(7)

              </li>
          </ul>
        </div>

        <h1>Tags</h1>
        <div class="nav-section">
          <ul class="tags">
              <li>
                <a href="/tagged/aws.html">AWS</a>&nbsp;(1)

              </li>
              <li>
                <a href="/tagged/authentication.html">Authentication</a>&nbsp;(1)

              </li>
              <li>
                <a href="/tagged/datamapper.html">DataMapper</a>&nbsp;(8)

              </li>
              <li>
                <a href="/tagged/gentoo.html">Gentoo</a>&nbsp;(1)

              </li>
              <li>
                <a href="/tagged/hypermedia.html">Hypermedia</a>&nbsp;(4)

              </li>
              <li>
                <a href="/tagged/let-s-encrypt.html">Let's Encrypt</a>&nbsp;(1)

              </li>
              <li>
                <a href="/tagged/linux.html">Linux</a>&nbsp;(2)

              </li>
              <li>
                <a href="/tagged/logging.html">Logging</a>&nbsp;(1)

              </li>
              <li>
                <a href="/tagged/merb.html">Merb</a>&nbsp;(3)

              </li>
              <li>
                <a href="/tagged/mysql.html">MySQL</a>&nbsp;(1)

              </li>
              <li>
                <a href="/tagged/progress-bar.html">Progress Bar</a>&nbsp;(1)

              </li>
              <li>
                <a href="/tagged/rails.html">Rails</a>&nbsp;(3)

              </li>
              <li>
                <a href="/tagged/resourceful.html">Resourceful</a>&nbsp;(3)

              </li>
              <li>
                <a href="/tagged/ruby.html">Ruby</a>&nbsp;(16)

              </li>
              <li>
                <a href="/tagged/meta.html">meta</a>&nbsp;(1)

              </li>
              <li>
                <a href="/tagged/tips.html">tips</a>&nbsp;(1)

              </li>
          </ul>
        </div>

      </nav>
    </div>

    <footer>
      <a rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by-sa/4.0/80x15.png" /></a> <span xmlns:dct="http://purl.org/dc/terms/" href="http://purl.org/dc/dcmitype/Text" property="dct:title" rel="dct:type">The Amazing Blog</span> by <a xmlns:cc="http://creativecommons.org/ns#" href="http://blog.theamazingrando.com" property="cc:attributionName" rel="cc:attributionURL">Paul Sadauskas</a> is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/">Creative Commons Attribution-ShareAlike 4.0 International License</a>.
    </footer>

  </body>
  <script>
    (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
    (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
    m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
    })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

    ga('create', 'UA-406374-8', 'auto');
    ga('send', 'pageview');

  </script>
</html>
